import { Injectable } from '@angular/core';
import { Observable, of } from 'rxjs';
import { HttpClient, HttpHeaders } from '@angular/common/http';

import { Hero } from './hero';
import { MessageService } from './message.service';

@Injectable({
  providedIn: 'root'
})
export class HeroService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  getHeroes(): Promise<Hero[]> {
    this.messageService.add('HeroService: fetched heroes');
    return this.http.get<Hero[]>(`http://172.16.3.185:5000/heroes/heroes`).toPromise()
  }

  getHero(id: number): Promise<Hero> {
    this.messageService.add(`HeroService: fetch hero id=${id}`);
    return this.http.get<Hero>(`http://172.16.3.185:5000/heroes/hero/${id}`).toPromise()
  }

  updateHero(hero: Hero): Promise<any> {
    this.messageService.add(`HeroService: save change: id=${hero.id}, name=${hero.name}`);
    return this.http.put<Hero>(`http://172.16.3.185:5000/heroes/hero/${hero.id}`, hero).toPromise()
  }
}
